"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ObjSetOp = void 0;
const clock_1 = require("../clock");
class ObjSetOp {
    constructor(id, obj, data) {
        this.id = id;
        this.obj = obj;
        this.data = data;
    }
    span() {
        return 0;
    }
    name() {
        return 'obj_set';
    }
    toString(tab = '') {
        let out = `"${this.name()}" ${(0, clock_1.toDisplayString)(this.id)}!${this.span()}, obj = ${(0, clock_1.toDisplayString)(this.obj)}`;
        for (let i = 0; i < this.data.length; i++) {
            const isLast = i === this.data.length - 1;
            out += `\n${tab}  ${isLast ? '└─' : '├─'} ${JSON.stringify(this.data[i][0])}: ${(0, clock_1.toDisplayString)(this.data[i][1])}`;
        }
        return out;
    }
}
exports.ObjSetOp = ObjSetOp;
