import { Finder } from './Finder';
import { JsonNode } from '../../types';
import { PatchBuilder } from '../../../json-crdt-patch/PatchBuilder';
import type { Model } from '../Model';
import type { Path } from '../../../json-pointer';
import { Patch } from '../../../json-crdt-patch/Patch';
export declare class ModelApi {
    readonly model: Model;
    builder: PatchBuilder;
    next: number;
    constructor(model: Model);
    find(): Finder;
    find(path: string | Path): JsonNode;
    val(path: string | Path): import("./ValueApi").ValueApi;
    str(path: string | Path): import("./StringApi").StringApi;
    bin(path: string | Path): import("./BinaryApi").BinaryApi;
    arr(path: string | Path): import("./ArrayApi").ArrayApi;
    obj(path: string | Path): import("./ObjectApi").ObjectApi;
    const(path: string | Path): import("./ConstApi").ConstApi;
    root(json: unknown): this;
    getRoot(): JsonNode;
    apply(): void;
    advance(): void;
    view(): unknown;
    flush(): Patch;
}
