"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StringApi = void 0;
const NodeApi_1 = require("./NodeApi");
const clock_1 = require("../../../json-crdt-patch/clock");
class StringApi extends NodeApi_1.NodeApi {
    ins(index, text) {
        const { api, node } = this;
        const nextTime = api.builder.nextTime();
        const after = node.insAt(index, (0, clock_1.ts)(api.builder.clock.sid, nextTime), text);
        if (!after)
            throw new Error('OUT_OF_BOUNDS');
        api.builder.insStr(node.id, after, text);
        api.advance();
        return this;
    }
    del(index, length) {
        const { api, node } = this;
        const spans = node.findInterval(index, length);
        if (!spans)
            throw new Error('OUT_OF_BOUNDS');
        node.delete(spans);
        api.builder.del(node.id, spans);
        api.advance();
        return this;
    }
}
exports.StringApi = StringApi;
