import { CborDecoderFast } from './CborDecoderFast';
import { JsonPackValue } from '../JsonPackValue';
export declare class CborDecoder extends CborDecoderFast {
    readAsMap(): Map<unknown, unknown>;
    readMap(minor: number): Map<unknown, unknown>;
    readMapRaw(length: number): Map<unknown, unknown>;
    readMapIndef(): Map<unknown, unknown>;
    skipN(n: number): void;
    skipAny(): void;
    skipAnyRaw(octet: number): void;
    skipMinorLen(minor: number): number;
    skipUNint(minor: number): void;
    skipBin(minor: number): void;
    skipBinChunk(): void;
    skipStr(minor: number): void;
    skipStrChunk(): void;
    skipArr(minor: number): void;
    skipObj(minor: number): void;
    skipTag(minor: number): void;
    skipTkn(minor: number): void;
    validate(value: Uint8Array, offset?: number, size?: number): void;
    decodeLevel(value: Uint8Array): unknown;
    readLevel(): unknown;
    readPrimitiveOrVal(): unknown | JsonPackValue;
    readAsValue(): JsonPackValue;
    readObjLevel(minor: number): Record<string, unknown>;
    readObjRawLevel(length: number): Record<string, unknown>;
    readObjIndefLevel(): Record<string, unknown>;
    readArrLevel(minor: number): unknown[];
    readArrRawLevel(length: number): unknown[];
    readArrIndefLevel(): unknown[];
}
