/// <reference types="node" />
import type { Worker } from 'worker_threads';
import type { WorkerMethod, WorkerMethodCh } from './types';
import type { WorkerPool } from './WorkerPool';
declare const enum TYPE {
    FN = 0,
    CH = 1
}
export declare class WorkerPoolModule {
    protected readonly pool: WorkerPool;
    readonly name: string;
    readonly file: string;
    protected readonly toId: Map<string, number>;
    protected readonly type: Map<string, TYPE>;
    constructor(pool: WorkerPool, name: string, file: string);
    setupWorker(worker: Worker): Promise<void>;
    fn<Request, Response>(name: string, worker?: Worker): WorkerMethod<Request, Response>;
    ch<Request, Incoming, Outgoing, Response>(name: string, worker?: Worker): WorkerMethodCh<Request, Incoming, Outgoing, Response>;
    api<Methods extends {
        [key: string]: WorkerMethod<any, any> | WorkerMethodCh<any, any, any, any>;
    }>(worker?: Worker): Methods;
}
export {};
