"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pool = void 0;
const WorkerPool_1 = require("./WorkerPool");
const __pool = new WorkerPool_1.WorkerPool();
let threadsStarted = false;
let threadsPromise;
const loadThreads = () => {
    if (threadsPromise)
        return threadsPromise;
    const cpuCountLessOne = require('os').cpus().length - 1;
    const maxThreads = Number(process.env.WP_MAX_THREADPOOL_SIZE) || 4;
    const threadCount = Math.min(Math.max(cpuCountLessOne, 1), maxThreads);
    threadsPromise = __pool
        .addThreads(threadCount)
        .then(() => {
        threadsStarted = true;
    })
        .catch(() => { });
    return threadsPromise;
};
const pool = async () => {
    if (!threadsStarted)
        await loadThreads();
    return __pool;
};
exports.pool = pool;
