import { IClock, ITimestampStruct, ITimespanStruct, Timestamp } from './clock';
import { Patch } from './Patch';
export declare class PatchBuilder {
    readonly clock: IClock;
    patch: Patch;
    constructor(clock: IClock);
    nextTime(): number;
    flush(): Patch;
    obj(): ITimestampStruct;
    arr(): ITimestampStruct;
    str(): ITimestampStruct;
    bin(): ITimestampStruct;
    const(value: unknown): ITimestampStruct;
    val(val: ITimestampStruct): ITimestampStruct;
    root(val: ITimestampStruct): ITimestampStruct;
    setKeys(obj: ITimestampStruct, data: [key: string, value: ITimestampStruct][]): ITimestampStruct;
    setVal(obj: ITimestampStruct, val: ITimestampStruct): ITimestampStruct;
    insStr(obj: ITimestampStruct, ref: ITimestampStruct, data: string): ITimestampStruct;
    insBin(obj: ITimestampStruct, ref: ITimestampStruct, data: Uint8Array): ITimestampStruct;
    insArr(arr: ITimestampStruct, ref: ITimestampStruct, data: ITimestampStruct[]): ITimestampStruct;
    del(obj: ITimestampStruct, what: ITimespanStruct[]): ITimestampStruct;
    noop(span: number): ITimestampStruct;
    jsonObj(json: object): ITimestampStruct;
    jsonArr(json: unknown[]): ITimestampStruct;
    jsonStr(json: string): ITimestampStruct;
    jsonBin(json: Uint8Array): ITimestampStruct;
    jsonVal(json: unknown): ITimestampStruct;
    json(json: unknown): ITimestampStruct;
    constOrJson(value: unknown): ITimestampStruct;
    maybeConst(value: unknown | Timestamp): Timestamp;
    private pad;
}
