"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinaryApi = void 0;
const NodeApi_1 = require("./NodeApi");
class BinaryApi extends NodeApi_1.NodeApi {
    ins(index, data) {
        const { api, node } = this;
        const after = !index ? node.id : node.find(index - 1);
        if (!after)
            throw new Error('OUT_OF_BOUNDS');
        api.builder.insBin(node.id, after, data);
        api.apply();
        return this;
    }
    del(index, length) {
        const { api, node } = this;
        const spans = node.findInterval(index, length);
        if (!spans)
            throw new Error('OUT_OF_BOUNDS');
        api.builder.del(node.id, spans);
        api.apply();
        return this;
    }
}
exports.BinaryApi = BinaryApi;
