import { Finder } from './Finder';
import type { JsonNode } from '../../types';
import type { ModelApi } from './ModelApi';
import type { Path } from '../../../json-pointer';
export declare class NodeApi<Node extends JsonNode, View = unknown> {
    protected readonly api: ModelApi;
    readonly node: Node;
    constructor(api: ModelApi, node: Node);
    find(): Finder;
    find(path: Path): JsonNode;
    val(path: Path): import("./ValueApi").ValueApi;
    str(path: Path): import("./StringApi").StringApi;
    bin(path: Path): import("./BinaryApi").BinaryApi;
    arr(path: Path): import("./ArrayApi").ArrayApi;
    obj(path: Path): import("./ObjectApi").ObjectApi;
    view(): View;
}
