"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValueLww = void 0;
const clock_1 = require("../../../json-crdt-patch/clock");
class ValueLww {
    constructor(doc, id, val) {
        this.doc = doc;
        this.id = id;
        this.val = val;
    }
    set(val) {
        if ((0, clock_1.compare)(val, this.val) <= 0 && this.val.sid !== 0)
            return;
        const oldVal = this.val;
        this.val = val;
        return oldVal;
    }
    node() {
        return this.doc.index.get(this.val);
    }
    view() {
        return this.node().view();
    }
    toString(tab = '') {
        const node = this.node();
        const nodeView = node ? node.toString(tab + '   ') : (0, clock_1.toDisplayString)(this.val);
        return `${this.constructor.name} ${(0, clock_1.toDisplayString)(this.id)}\n${tab}└─ ${nodeView}`;
    }
    children(callback) {
        callback(this.node());
    }
    container() {
        const child = this.node();
        return child ? child.container() : undefined;
    }
}
exports.ValueLww = ValueLww;
