import { AbstractRga, Chunk } from '../rga/AbstractRga';
import { ITimestampStruct } from '../../../json-crdt-patch/clock';
import { Model } from '../../model';
import type { JsonNode } from '../../types';
declare type E = ITimestampStruct;
export declare class ArrayChunk implements Chunk<E[]> {
    readonly id: ITimestampStruct;
    span: number;
    del: boolean;
    data: E[] | undefined;
    len: number;
    p: ArrayChunk | undefined;
    l: ArrayChunk | undefined;
    r: ArrayChunk | undefined;
    s: ArrayChunk | undefined;
    constructor(id: ITimestampStruct, span: number, data: E[] | undefined);
    merge(data: E[]): void;
    split(ticks: number): ArrayChunk;
    delete(): void;
    clone(): ArrayChunk;
}
export declare class ArrayRga extends AbstractRga<E[]> implements JsonNode {
    protected readonly doc: Model;
    constructor(doc: Model, id: ITimestampStruct);
    protected create(): ArrayRga;
    createChunk(id: ITimestampStruct, data: E[] | undefined): ArrayChunk;
    protected onViewChange(): void;
    private _view;
    view(): unknown[];
    children(callback: (node: JsonNode) => void): void;
    protected formatChunk(chunk: ArrayChunk, tab: string, side: 'l' | 'r' | ''): string;
    get(position: number): E | undefined;
    getNode(position: number): JsonNode | undefined;
    getById(id: ITimestampStruct): E | undefined;
    container(): JsonNode | undefined;
}
export {};
