import { JsonPackExtension } from '../JsonPackExtension';
import type { CachedUtf8Decoder } from '../../util/buffers/utf8/CachedUtf8Decoder';
import type { IReader, IReaderResettable } from '../../util/buffers';
export declare class MsgPackDecoderFast<R extends IReader & IReaderResettable = IReader & IReaderResettable> {
    reader: R;
    protected readonly keyDecoder: CachedUtf8Decoder;
    constructor(reader?: R, keyDecoder?: CachedUtf8Decoder);
    decode(uint8: Uint8Array): unknown;
    val(): unknown;
    protected str(size: number): string;
    protected obj(size: number): object;
    protected key(): string;
    protected arr(size: number): unknown[];
    protected bin(size: number): Uint8Array;
    protected ext(size: number): JsonPackExtension;
    protected back(bytes: number): void;
}
