"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MsgPackEncoder = void 0;
const MsgPackEncoderFast_1 = require("./MsgPackEncoderFast");
const isUint8Array_1 = require("../../util/buffers/isUint8Array");
const JsonPackExtension_1 = require("../JsonPackExtension");
const JsonPackValue_1 = require("../JsonPackValue");
class MsgPackEncoder extends MsgPackEncoderFast_1.MsgPackEncoderFast {
    encodeAny(json) {
        switch (json) {
            case null:
                return this.writer.u8(192);
            case false:
                return this.writer.u8(194);
            case true:
                return this.writer.u8(195);
        }
        if (json instanceof Array)
            return this.encodeArray(json);
        switch (typeof json) {
            case 'number':
                return this.encodeNumber(json);
            case 'string':
                return this.encodeString(json);
            case 'object': {
                if (json instanceof JsonPackValue_1.JsonPackValue)
                    return this.writer.buf(json.val, json.val.byteLength);
                if (json instanceof JsonPackExtension_1.JsonPackExtension)
                    return this.encodeExt(json);
                if ((0, isUint8Array_1.isUint8Array)(json))
                    return this.encodeBinary(json);
                return this.encodeObject(json);
            }
            case 'undefined':
                return this.writer.u8(193);
        }
    }
}
exports.MsgPackEncoder = MsgPackEncoder;
