/// <reference types="node" />
import { Defer } from '../Defer';
import { Worker } from 'worker_threads';
import { WorkerPoolModule } from './WorkerPoolModule';
import type { TransferList } from './types';
export declare class WorkerPool {
    seq: number;
    protected nextWorker: number;
    protected readonly workers: Worker[];
    protected readonly requests: Map<number, Defer<unknown>>;
    modules: Map<string, WorkerPoolModule>;
    queue(): number;
    addThread(): Promise<void>;
    addThreads(count: number): Promise<void>;
    load(name: string, file: string): Promise<WorkerPoolModule>;
    exec(id: number, data: unknown, transferList: TransferList | undefined, worker?: Worker): Promise<unknown>;
    private onResponse;
    pickWorker(): Worker;
}
