import { NodeApi } from './NodeApi';
import { ts } from '../../../json-crdt-patch/clock';
export class StringApi extends NodeApi {
    ins(index, text) {
        const { api, node } = this;
        const nextTime = api.builder.nextTime();
        const after = node.insAt(index, ts(api.builder.clock.sid, nextTime), text);
        if (!after)
            throw new Error('OUT_OF_BOUNDS');
        api.builder.insStr(node.id, after, text);
        api.advance();
        return this;
    }
    del(index, length) {
        const { api, node } = this;
        const spans = node.findInterval(index, length);
        if (!spans)
            throw new Error('OUT_OF_BOUNDS');
        node.delete(spans);
        api.builder.del(node.id, spans);
        api.advance();
        return this;
    }
}
