import { compare, toDisplayString } from '../../../json-crdt-patch/clock';
export class ValueLww {
    doc;
    id;
    val;
    constructor(doc, id, val) {
        this.doc = doc;
        this.id = id;
        this.val = val;
    }
    set(val) {
        if (compare(val, this.val) <= 0 && this.val.sid !== 0)
            return;
        const oldVal = this.val;
        this.val = val;
        return oldVal;
    }
    node() {
        return this.doc.index.get(this.val);
    }
    view() {
        return this.node().view();
    }
    toString(tab = '') {
        const node = this.node();
        const nodeView = node ? node.toString(tab + '   ') : toDisplayString(this.val);
        return `${this.constructor.name} ${toDisplayString(this.id)}\n${tab}└─ ${nodeView}`;
    }
    children(callback) {
        callback(this.node());
    }
    container() {
        const child = this.node();
        return child ? child.container() : undefined;
    }
}
