import { JsonPackExtension } from '../JsonPackExtension';
import { JsonPackValue } from '../JsonPackValue';
import type { CachedUtf8Decoder } from '../../util/buffers/utf8/CachedUtf8Decoder';
import type { IReader, IReaderResettable } from '../../util/buffers';
export declare class CborDecoderFast {
    reader: IReader & IReaderResettable;
    protected readonly keyDecoder: CachedUtf8Decoder;
    constructor(reader?: IReader & IReaderResettable, keyDecoder?: CachedUtf8Decoder);
    decode(uint8: Uint8Array): unknown;
    readAny(): unknown;
    readAnyRaw(octet: number): unknown;
    readMinorLen(minor: number): number;
    readUint(minor: number): number | bigint;
    readNint(minor: number): number | bigint;
    readBin(minor: number): Uint8Array;
    readBinChunk(): Uint8Array;
    readStr(minor: number): string;
    readStrLen(minor: number): number;
    readStrChunk(): string;
    readArr(minor: number): unknown[];
    readArrRaw(length: number): unknown[];
    readArrIndef(): unknown[];
    readObj(minor: number): Record<string, unknown>;
    readObjRaw(length: number): Record<string, unknown>;
    readObjIndef(): Record<string, unknown>;
    readObjKeyAsStr(): string;
    readTag(minor: number): JsonPackExtension<unknown>;
    readTagRaw(tag: number): JsonPackExtension<unknown>;
    readTkn(minor: number): number | true | false | null | undefined | JsonPackValue<number>;
    f16(): number;
}
