import { MsgPackEncoderFast } from './MsgPackEncoderFast';
import { isUint8Array } from '../../util/buffers/isUint8Array';
import { JsonPackExtension } from '../JsonPackExtension';
import { JsonPackValue } from '../JsonPackValue';
export class MsgPackEncoder extends MsgPackEncoderFast {
    encodeAny(json) {
        switch (json) {
            case null:
                return this.writer.u8(192);
            case false:
                return this.writer.u8(194);
            case true:
                return this.writer.u8(195);
        }
        if (json instanceof Array)
            return this.encodeArray(json);
        switch (typeof json) {
            case 'number':
                return this.encodeNumber(json);
            case 'string':
                return this.encodeString(json);
            case 'object': {
                if (json instanceof JsonPackValue)
                    return this.writer.buf(json.val, json.val.byteLength);
                if (json instanceof JsonPackExtension)
                    return this.encodeExt(json);
                if (isUint8Array(json))
                    return this.encodeBinary(json);
                return this.encodeObject(json);
            }
            case 'undefined':
                return this.writer.u8(193);
        }
    }
}
