import type { Comparator, HeadlessNode, ITreeNode } from './types';
export declare const find: <K = unknown, V = unknown>(root: ITreeNode<K, V> | undefined, key: K, comparator: Comparator<K>) => ITreeNode<K, V> | undefined;
export declare const findOrNextLower: <K = unknown, V = unknown>(root: ITreeNode<K, V> | undefined, key: K, comparator: Comparator<K>) => ITreeNode<K, V> | undefined;
export declare const insertRight: <K = unknown, V = unknown>(node: ITreeNode<K, V>, p: ITreeNode<K, V>) => void;
export declare const insertLeft: <K = unknown, V = unknown>(node: ITreeNode<K, V>, p: ITreeNode<K, V>) => void;
export declare const insert: <K = unknown, V = unknown>(root: ITreeNode<K, V> | undefined, node: ITreeNode<K, V>, comparator: Comparator<K>) => ITreeNode<K, V>;
export declare const remove: <N extends HeadlessNode>(root: N | undefined, node: N) => N | undefined;
export declare const splay: <K = unknown, V = unknown>(root: ITreeNode<K, V>, node: ITreeNode<K, V>, repeat: number) => ITreeNode<K, V>;
export declare const rSplay: <N extends HeadlessNode>(c2: N, c1: N) => N;
export declare const lSplay: <N extends HeadlessNode>(c2: N, c1: N) => N;
export declare const rrSplay: <N extends HeadlessNode>(root: N, c3: N, c2: N, c1: N) => N;
export declare const llSplay: <N extends HeadlessNode>(root: N, c3: N, c2: N, c1: N) => N;
export declare const lrSplay: <N extends HeadlessNode>(root: N, c3: N, c2: N, c1: N) => N;
export declare const rlSplay: <N extends HeadlessNode>(root: N, c3: N, c2: N, c1: N) => N;
