import { WorkerPool } from './WorkerPool';
const __pool = new WorkerPool();
let threadsStarted = false;
let threadsPromise;
const loadThreads = () => {
    if (threadsPromise)
        return threadsPromise;
    const cpuCountLessOne = require('os').cpus().length - 1;
    const maxThreads = Number(process.env.WP_MAX_THREADPOOL_SIZE) || 4;
    const threadCount = Math.min(Math.max(cpuCountLessOne, 1), maxThreads);
    threadsPromise = __pool
        .addThreads(threadCount)
        .then(() => {
        threadsStarted = true;
    })
        .catch(() => { });
    return threadsPromise;
};
export const pool = async () => {
    if (!threadsStarted)
        await loadThreads();
    return __pool;
};
