"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrayApi = void 0;
var tslib_1 = require("tslib");
var NodeApi_1 = require("./NodeApi");
var ArrayApi = (function (_super) {
    tslib_1.__extends(ArrayApi, _super);
    function ArrayApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ArrayApi.prototype.ins = function (index, values) {
        var _a = this, api = _a.api, node = _a.node;
        var builder = api.builder;
        var after = !index ? node.id : node.find(index - 1);
        if (!after)
            throw new Error('OUT_OF_BOUNDS');
        var valueIds = [];
        for (var i = 0; i < values.length; i++)
            valueIds.push(builder.json(values[i]));
        builder.insArr(node.id, after, valueIds);
        api.apply();
        return this;
    };
    ArrayApi.prototype.del = function (index, length) {
        var _a = this, api = _a.api, node = _a.node;
        var spans = node.findInterval(index, length);
        if (!spans)
            throw new Error('OUT_OF_BOUNDS');
        api.builder.del(node.id, spans);
        api.apply();
        return this;
    };
    return ArrayApi;
}(NodeApi_1.NodeApi));
exports.ArrayApi = ArrayApi;
