"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BinaryApi = void 0;
var tslib_1 = require("tslib");
var NodeApi_1 = require("./NodeApi");
var BinaryApi = (function (_super) {
    tslib_1.__extends(BinaryApi, _super);
    function BinaryApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BinaryApi.prototype.ins = function (index, data) {
        var _a = this, api = _a.api, node = _a.node;
        var after = !index ? node.id : node.find(index - 1);
        if (!after)
            throw new Error('OUT_OF_BOUNDS');
        api.builder.insBin(node.id, after, data);
        api.apply();
        return this;
    };
    BinaryApi.prototype.del = function (index, length) {
        var _a = this, api = _a.api, node = _a.node;
        var spans = node.findInterval(index, length);
        if (!spans)
            throw new Error('OUT_OF_BOUNDS');
        api.builder.del(node.id, spans);
        api.apply();
        return this;
    };
    return BinaryApi;
}(NodeApi_1.NodeApi));
exports.BinaryApi = BinaryApi;
