import { ArrayApi } from './ArrayApi';
import { BinaryApi } from './BinaryApi';
import { ObjectApi } from './ObjectApi';
import { Path } from '../../../json-pointer';
import { StringApi } from './StringApi';
import { ValueApi } from './ValueApi';
import type { JsonNode } from '../../types';
import type { ModelApi } from './ModelApi';
import { ConstApi } from './ConstApi';
export declare class Finder {
    protected readonly node: JsonNode;
    protected readonly api: ModelApi;
    constructor(node: JsonNode, api: ModelApi);
    find(path: string | Path): JsonNode;
    val(path: string | Path): ValueApi;
    str(path: string | Path): StringApi;
    bin(path: string | Path): BinaryApi;
    arr(path: string | Path): ArrayApi;
    obj(path: string | Path): ObjectApi;
    const(path: string | Path): ConstApi;
}
