"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StringApi = void 0;
var tslib_1 = require("tslib");
var NodeApi_1 = require("./NodeApi");
var clock_1 = require("../../../json-crdt-patch/clock");
var StringApi = (function (_super) {
    tslib_1.__extends(StringApi, _super);
    function StringApi() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StringApi.prototype.ins = function (index, text) {
        var _a = this, api = _a.api, node = _a.node;
        var nextTime = api.builder.nextTime();
        var after = node.insAt(index, (0, clock_1.ts)(api.builder.clock.sid, nextTime), text);
        if (!after)
            throw new Error('OUT_OF_BOUNDS');
        api.builder.insStr(node.id, after, text);
        api.advance();
        return this;
    };
    StringApi.prototype.del = function (index, length) {
        var _a = this, api = _a.api, node = _a.node;
        var spans = node.findInterval(index, length);
        if (!spans)
            throw new Error('OUT_OF_BOUNDS');
        node.delete(spans);
        api.builder.del(node.id, spans);
        api.advance();
        return this;
    };
    return StringApi;
}(NodeApi_1.NodeApi));
exports.StringApi = StringApi;
