"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PartialEditFactory = void 0;
var ClockTable_1 = require("../../json-crdt-patch/codec/clock/ClockTable");
var PartialEdit_1 = require("./PartialEdit");
var PartialEditFactory = (function () {
    function PartialEditFactory(decoder, encoder) {
        this.decoder = decoder;
        this.encoder = encoder;
    }
    PartialEditFactory.prototype.startPartialEdit = function (clockBlob) {
        var reader = this.decoder.dec.reader;
        reader.reset(clockBlob);
        var clockTable = ClockTable_1.ClockTable.decode(reader);
        var partialEdit = new PartialEdit_1.PartialEdit(this.decoder, this.encoder, clockTable);
        return partialEdit;
    };
    return PartialEditFactory;
}());
exports.PartialEditFactory = PartialEditFactory;
