import type { JsonNode } from '../../types';
import { ITimestampStruct } from '../../../json-crdt-patch/clock';
import { AbstractRga, Chunk } from '../rga/AbstractRga';
export declare class StringChunk implements Chunk<string> {
    readonly id: ITimestampStruct;
    span: number;
    del: boolean;
    data: string;
    len: number;
    p: StringChunk | undefined;
    l: StringChunk | undefined;
    r: StringChunk | undefined;
    s: StringChunk | undefined;
    constructor(id: ITimestampStruct, span: number, str: string);
    merge(str: string): void;
    split(ticks: number): StringChunk;
    delete(): void;
    clone(): StringChunk;
}
export declare class StringRga extends AbstractRga<string> implements JsonNode {
    protected create(): StringRga;
    createChunk(id: ITimestampStruct, str: string | undefined): StringChunk;
    protected onViewChange(): void;
    private _view;
    view(): string;
    children(): void;
    container(): JsonNode | undefined;
}
