"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hash = void 0;
var hashStr__ = function (state, str) {
    var i = str.length;
    while (i)
        state = (state * 33) ^ str.charCodeAt(--i);
    return state;
};
var sort__ = function (arr) {
    var length = arr.length;
    for (var i = 1; i < length; i++) {
        var currentValue = arr[i];
        var position = i;
        while (position !== 0 && arr[position - 1] > currentValue) {
            arr[position] = arr[position - 1];
            position--;
        }
        arr[position] = currentValue;
    }
    return arr;
};
var hash__ = function (state, json) {
    switch (typeof json) {
        case 'number':
            return (state * 33) ^ json;
        case 'string':
            return hashStr__((state * 33) ^ 600000, json);
        case 'object': {
            if (json === null)
                return (state * 33) ^ 300000;
            if (json instanceof Array) {
                var length_1 = json.length;
                state = (state * 33) ^ 400000;
                for (var i = 0; i < length_1; i++)
                    state = hash__(state, json[i]);
                return state;
            }
            state = (state * 33) ^ 500000;
            var keys = sort__(Object.keys(json));
            var length_2 = keys.length;
            for (var i = 0; i < length_2; i++) {
                var key = keys[i];
                state = hashStr__(state, key);
                state = hash__(state, json[key]);
            }
            return state;
        }
        case 'boolean':
            return (state * 33) ^ (json ? 100000 : 200000);
    }
    return state;
};
var hash = function (json) { return hash__(5381, json) >>> 0; };
exports.hash = hash;
