"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.apply = void 0;
var apply = function (str, op) {
    var length = op.length;
    var res = '';
    var offset = 0;
    for (var i = 0; i < length; i++) {
        var component = op[i];
        switch (typeof component) {
            case 'number': {
                if (component > 0) {
                    var end = offset + component;
                    res += str.substring(offset, end);
                    offset = end;
                }
                else
                    offset -= component;
                break;
            }
            case 'string':
                res += component;
                break;
            case 'object':
                offset += component[0].length;
                break;
        }
    }
    return res + str.substring(offset);
};
exports.apply = apply;
