import type { IWriter, IWriterGrowable } from '../../util/buffers';
export declare class CborEncoderFast {
    readonly writer: IWriter & IWriterGrowable;
    constructor(writer?: IWriter & IWriterGrowable);
    encode(value: unknown): Uint8Array;
    writeAny(value: unknown): void;
    writeCbor(): void;
    writeEnd(): void;
    encodeNumber(num: number): void;
    encodeInteger(int: number): void;
    encodeUint(uint: number): void;
    encodeNint(int: number): void;
    writeFloat(float: number): void;
    writeBin(buf: Uint8Array): void;
    writeBinHdr(length: number): void;
    writeStartBin(): void;
    writeStr(str: string): void;
    writeStartStr(): void;
    writeArr(arr: unknown[]): void;
    writeArrHdr(length: number): void;
    writeStartArr(): void;
    writeObj(obj: Record<string, unknown>): void;
    writeMapHdr(length: number): void;
    writeStartMap(): void;
    writeTag(tag: number, value: unknown): void;
    writeTagHdr(tag: number): void;
    writeTkn(value: number): void;
}
