"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MsgPackEncoder = void 0;
var tslib_1 = require("tslib");
var MsgPackEncoderFast_1 = require("./MsgPackEncoderFast");
var isUint8Array_1 = require("../../util/buffers/isUint8Array");
var JsonPackExtension_1 = require("../JsonPackExtension");
var JsonPackValue_1 = require("../JsonPackValue");
var MsgPackEncoder = (function (_super) {
    tslib_1.__extends(MsgPackEncoder, _super);
    function MsgPackEncoder() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MsgPackEncoder.prototype.encodeAny = function (json) {
        switch (json) {
            case null:
                return this.writer.u8(192);
            case false:
                return this.writer.u8(194);
            case true:
                return this.writer.u8(195);
        }
        if (json instanceof Array)
            return this.encodeArray(json);
        switch (typeof json) {
            case 'number':
                return this.encodeNumber(json);
            case 'string':
                return this.encodeString(json);
            case 'object': {
                if (json instanceof JsonPackValue_1.JsonPackValue)
                    return this.writer.buf(json.val, json.val.byteLength);
                if (json instanceof JsonPackExtension_1.JsonPackExtension)
                    return this.encodeExt(json);
                if ((0, isUint8Array_1.isUint8Array)(json))
                    return this.encodeBinary(json);
                return this.encodeObject(json);
            }
            case 'undefined':
                return this.writer.u8(193);
        }
    };
    return MsgPackEncoder;
}(MsgPackEncoderFast_1.MsgPackEncoderFast));
exports.MsgPackEncoder = MsgPackEncoder;
