import { IWriter, IWriterGrowable } from '../../util/buffers';
import { JsonPackExtension } from '../JsonPackExtension';
import { IMessagePackEncoder } from './types';
export declare class MsgPackEncoderFast<W extends IWriter & IWriterGrowable = IWriter & IWriterGrowable> implements IMessagePackEncoder {
    readonly writer: W;
    constructor(writer?: W);
    encode(json: unknown): Uint8Array;
    encodeAny(json: unknown): void;
    protected encodeFloat64(num: number): void;
    encodeUnsignedInteger(num: number): void;
    encodeNegativeInteger(num: number): void;
    encodeNumber(num: number): void;
    encodeNull(): void;
    encodeTrue(): void;
    encodeFalse(): void;
    encodeBoolean(bool: boolean): void;
    encodeStringHeader(length: number): void;
    encodeString(str: string): void;
    encodeAsciiString(str: string): void;
    encodeArrayHeader(length: number): void;
    encodeArray(arr: unknown[]): void;
    encodeObjectHeader(length: number): void;
    encodeObject(obj: Record<string, unknown>): void;
    encodeExtHeader(type: number, length: number): void;
    encodeExt(ext: JsonPackExtension): void;
    encodeBinaryHeader(length: number): void;
    encodeBinary(buf: Uint8Array): void;
}
