"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
exports.default = (function (buf, start, length) {
    var offset = start;
    var end = offset + length;
    var units = [];
    var result = '';
    while (offset < end) {
        var byte1 = buf[offset++];
        if ((byte1 & 0x80) === 0) {
            units.push(byte1);
        }
        else if ((byte1 & 0xe0) === 0xc0) {
            var byte2 = buf[offset++] & 0x3f;
            units.push(((byte1 & 0x1f) << 6) | byte2);
        }
        else if ((byte1 & 0xf0) === 0xe0) {
            var byte2 = buf[offset++] & 0x3f;
            var byte3 = buf[offset++] & 0x3f;
            units.push(((byte1 & 0x1f) << 12) | (byte2 << 6) | byte3);
        }
        else if ((byte1 & 0xf8) === 0xf0) {
            var byte2 = buf[offset++] & 0x3f;
            var byte3 = buf[offset++] & 0x3f;
            var byte4 = buf[offset++] & 0x3f;
            var unit = ((byte1 & 0x07) << 0x12) | (byte2 << 0x0c) | (byte3 << 0x06) | byte4;
            if (unit > 0xffff) {
                unit -= 0x10000;
                units.push(((unit >>> 10) & 0x3ff) | 0xd800);
                unit = 0xdc00 | (unit & 0x3ff);
            }
            units.push(unit);
        }
        else {
            units.push(byte1);
        }
        if (units.length >= 1000) {
            result += String.fromCharCode.apply(String, tslib_1.__spreadArray([], tslib_1.__read(units), false));
            units.length = 0;
        }
    }
    if (units.length > 0)
        result += String.fromCharCode.apply(String, tslib_1.__spreadArray([], tslib_1.__read(units), false));
    return result;
});
