"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var v10_1 = tslib_1.__importDefault(require("./v10"));
var decode = v10_1.default;
var hasBuffer = typeof Buffer !== 'undefined';
var utf8Slice = hasBuffer ? Buffer.prototype.utf8Slice : null;
if (utf8Slice) {
    decode = function (buf, start, length) {
        return length <= 10 ? (0, v10_1.default)(buf, start, length) : utf8Slice.call(buf, start, start + length);
    };
}
else {
    var from_1 = hasBuffer ? Buffer.from : null;
    if (from_1) {
        decode = function (buf, start, length) {
            return length < 30
                ? (0, v10_1.default)(buf, start, length)
                : from_1(buf)
                    .subarray(start, start + length)
                    .toString();
        };
    }
    else if (typeof TextDecoder !== 'undefined') {
        var decoder_1 = new TextDecoder();
        decode = function (buf, start, length) {
            return length < 150 ? (0, v10_1.default)(buf, start, length) : decoder_1.decode(buf.subarray(start, start + length));
        };
    }
}
exports.default = decode;
