"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pool = void 0;
var tslib_1 = require("tslib");
var WorkerPool_1 = require("./WorkerPool");
var __pool = new WorkerPool_1.WorkerPool();
var threadsStarted = false;
var threadsPromise;
var loadThreads = function () {
    if (threadsPromise)
        return threadsPromise;
    var cpuCountLessOne = require('os').cpus().length - 1;
    var maxThreads = Number(process.env.WP_MAX_THREADPOOL_SIZE) || 4;
    var threadCount = Math.min(Math.max(cpuCountLessOne, 1), maxThreads);
    threadsPromise = __pool
        .addThreads(threadCount)
        .then(function () {
        threadsStarted = true;
    })
        .catch(function () { });
    return threadsPromise;
};
var pool = function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
    return tslib_1.__generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!!threadsStarted) return [3, 2];
                return [4, loadThreads()];
            case 1:
                _a.sent();
                _a.label = 2;
            case 2: return [2, __pool];
        }
    });
}); };
exports.pool = pool;
