/// <reference types="node" />
import { WorkerResponse } from '../WorkerResponse';
import type { MessagePort } from 'worker_threads';
import type { WPMsgExecRequest, WPMsgLoad, WorkerFn, WPMsgChannel } from '../types';
import { WorkerChannel } from '../WorkerChannel';
export declare class WorkerRuntime {
    protected readonly port: MessagePort;
    protected readonly fn: (WorkerFn | WorkerChannel)[];
    protected readonly channels: Map<number, (data: unknown) => void>;
    constructor(port: MessagePort);
    protected onChannelMsg(msg: WPMsgChannel): void;
    protected onRequest([seq, method, data]: WPMsgExecRequest): void;
    protected onFn(seq: number, fn: WorkerFn, data: unknown): void;
    protected onCh(seq: number, fn: WorkerChannel, data: unknown): Promise<void>;
    protected sendResponse<Response>(seq: number, response: Response | WorkerResponse<Response>): void;
    protected sendError(seq: number, error: unknown): void;
    protected onLoad({ file }: WPMsgLoad): void;
    ready(): void;
}
